"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSubsocialApi = exports.setSubsocialConfig = exports.getConnectionConfig = exports.CRUST_TEST_AUTH_KEY = void 0;
const api_1 = require("@subsocial/api");
const DEFAULT_STAGING_CONFIG = {
    substrateUrl: 'wss://rco-para.subsocial.network',
    ipfsNodeUrl: 'https://crustwebsites.net',
    postConnectConfig: (api) => {
        api.ipfs.setWriteHeaders({
            authorization: 'Basic ' + exports.CRUST_TEST_AUTH_KEY,
        });
    },
};
const DEFAULT_PROD_CONFIG = {
    substrateUrl: 'wss://para.f3joule.space',
    ipfsNodeUrl: 'https://crustwebsites.net',
};
exports.CRUST_TEST_AUTH_KEY = 'c3ViLTVGQTluUURWZzI2N0RFZDhtMVp5cFhMQm52TjdTRnhZd1Y3bmRxU1lHaU45VFRwdToweDEwMmQ3ZmJhYWQwZGUwNzFjNDFmM2NjYzQzYmQ0NzIxNzFkZGFiYWM0MzEzZTc5YTY3ZWExOWM0OWFlNjgyZjY0YWUxMmRlY2YyNzhjNTEwZGY4YzZjZTZhYzdlZTEwNzY2N2YzYTBjZjM5OGUxN2VhMzAyMmRkNmEyYjc1OTBi'; // can only be used for testnet.
let subsocialApi = null;
const presets = {
    staging: DEFAULT_STAGING_CONFIG,
    prod: DEFAULT_PROD_CONFIG,
};
const DEFAULT_CONFIG_PRESET = 'staging';
let config = presets[DEFAULT_CONFIG_PRESET];
function getConnectionConfig() {
    return config;
}
exports.getConnectionConfig = getConnectionConfig;
const setSubsocialConfig = (preset, customConfig) => {
    config = { ...presets[preset], ...customConfig };
};
exports.setSubsocialConfig = setSubsocialConfig;
const getSubsocialApi = async (renew) => {
    if (subsocialApi && !renew)
        return subsocialApi;
    const api = connectToSubsocialApi(config);
    subsocialApi = api;
    return subsocialApi;
};
exports.getSubsocialApi = getSubsocialApi;
async function connectToSubsocialApi(config) {
    const { ipfsNodeUrl, substrateUrl, postConnectConfig } = config;
    const substrateApi = await (0, api_1.getSubstrateApi)(substrateUrl);
    const api = new api_1.SubsocialApi({
        ipfsNodeUrl,
        substrateApi,
        useServer: {
            httpRequestMethod: 'get',
        },
    });
    postConnectConfig && postConnectConfig(api);
    return api;
}
